package yrpg.application.crmvisit.plugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.Date;
import java.util.EventObject;

/**
 * 动态表单插件
 */
public class crmVisitDetailFormPlugin extends AbstractFormPlugin implements Plugin {
    @Override
    public void setView(IFormView formView) {
        super.setView(formView);
        System.out.println(formView);

    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
//        Object yrpg_sign_in_statue = this.getModel().getValue("yrpg_billstatusfield");
//        System.out.println(yrpg_sign_in_statue);
//        if(Objects.isNull(yrpg_sign_in_statue)){
//            this.getView().setVisible(false, "yrpg_flex_edit");
//        }else if(("1").equals(yrpg_sign_in_statue)){
//            this.getView().setVisible(false, "yrpg_flex_add");
//            this.getView().setVisible(true, "yrpg_flex_edit");
//            this.getView().setVisible(true, "yrpg_flex_basic");
//            this.getView().setVisible(true, "yrpg_flex_signin");
//            this.getView().setVisible(false, "yrpg_flex_signout");
//            this.getView().setVisible(false, "yrpg_flex_summary");
//        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);

    }

    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate source = (FormOperate) args.getSource();
        String opKey = source.getOperateKey();
        if (opKey.equals("save")) {
            //提交
            String text = String.valueOf(this.getModel().getValue("yrpg_textareafield")).trim();
            if (!text.isEmpty()) {
                this.getModel().setValue("yrpg_taskstatus", "B");
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
            }
        } else if (opKey.equals("signin")) {
            //签到
            String img_1 = String.valueOf(this.getModel().getValue("yrpg_sign_in_img_2"));
            String img_2 = String.valueOf(this.getModel().getValue("yrpg_sign_in_img_1"));
            if (img_1.isEmpty() && img_2.isEmpty()) {
                args.setCancel(true);
                this.getView().showTipNotification("请上传签到图片", 3000);
            } else {
                this.getModel().setValue("yrpg_taskstatus", "C");
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
            }
        } else if (opKey.equals("signout")) {
            //签退
            String img_1 = String.valueOf(this.getModel().getValue("yrpg_sign_out_img_1"));
            String img_2 = String.valueOf(this.getModel().getValue("yrpg_sign_out_img_2"));
            if (img_1.isEmpty() && img_2.isEmpty()) {
                args.setCancel(true);
                this.getView().showTipNotification("请上传签退图片", 3000);
                return;
            }
            Date in_time = (Date) this.getModel().getValue("yrpg_sign_in_time");
            Date out_time = (Date) this.getModel().getValue("yrpg_sign_out_time");
            long minutes = (out_time.getTime() - in_time.getTime()) / (60 * 1000);
            if (minutes < 10) {
                args.setCancel(true);
                this.getView().showTipNotification("还未到签退时间", 3000);
            } else {
                this.getModel().setValue("yrpg_taskstatus", "D");
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
            }
        } else if (opKey.equals("summary")) {
            String summarize = String.valueOf(this.getModel().getValue("yrpg_textareafield1")).trim();
            if (!summarize.isEmpty()) {
                this.getModel().setValue("yrpg_taskstatus", "E");
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
            } else {
                args.setCancel(true);
                this.getView().showTipNotification("请填写总结", 3000);
            }
        }
    }

    @Override
    public void createNewData(BizDataEventArgs e) {
        super.createNewData(e);
    }

    private void getFormViewInstance() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();


    }
}
